/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * TotalCostScriptedCalculatedValue
 *
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.acme.providers.script.AttributeValueAnalyzer");
dojo.require("com.ibm.team.workitem.api.common.WorkItemAttributes");
dojo.require("dojo.date");
dojo.require("dojo.date.stamp");


(function() {
	var doDebug = true;
	var scriptname = "AttributeValueAnalyzer";
	var WorkItemAttributes = com.ibm.team.workitem.api.common.WorkItemAttributes;

dojo.declare("com.acme.providers.script.AttributeValueAnalyzer", null, {

    getValue: function(attributeId, workItem, configuration) {
    	debug("- Start"); 

    	var out = "Attribute Values:\n";
		
		out+=getAttributeData("ID: ", WorkItemAttributes.ID);
		out+=getAttributeData("TYPE: ", WorkItemAttributes.TYPE);
		out+=getAttributeData("Summary: ", WorkItemAttributes.SUMMARY);
		out+=getAttributeData("Creator: ", WorkItemAttributes.CREATOR);
		out+=getAttributeData("Owner: ", WorkItemAttributes.OWNER);
		out+=getAttributeData("Project Area: ", WorkItemAttributes.PROJECT_AREA);
		out+=getAttributeData("State: ", WorkItemAttributes.STATE);
		out+=getAttributeData("Resolution: ", WorkItemAttributes.RESOLUTION);
		out+=getAttributeData("Found in: ", WorkItemAttributes.FOUND_IN);
		out+=getAttributeData("Severity: ", WorkItemAttributes.SEVERITY);
		out+=getAttributeData("Priority: ", WorkItemAttributes.PRIORITY);
		out+=getAttributeData("Creation Date: ", WorkItemAttributes.CREATION_DATE);
		var creationDate= dojo.date.stamp.fromISOString(workItem.getValue(WorkItemAttributes.CREATION_DATE));
		out += "Creation Date " + creationDate + "\n\n";
		out+=getAttributeData("Due Date: ", WorkItemAttributes.DUE_DATE);
		var dueDate= dojo.date.stamp.fromISOString(workItem.getValue(WorkItemAttributes.DUE_DATE));
		out += "Due Date " + dueDate + "\n\n";
		out+=getAttributeData("Estimate: ", WorkItemAttributes.ESTIMATE);
		out+=getAttributeData("Corrected Estimate: ", WorkItemAttributes.CORRECTED_ESTIMATE);
		out+=getAttributeData("Time Spent: ", WorkItemAttributes.TIME_SPENT);
		out+=getAttributeData("Filed Against: ", WorkItemAttributes.FILED_AGAINST);
		out+=getAttributeData("Planned For: ", WorkItemAttributes.Resolver);
		out+=getAttributeData("Resolution Date: ", WorkItemAttributes.RESOLUTION_DATE);
		out+=getAttributeData("Tags: ", WorkItemAttributes.TAGS);
		out+=getAttributeData("Modified Date: ", WorkItemAttributes.MODIFIED);
		var modifiedDate= dojo.date.stamp.fromISOString(workItem.getValue(WorkItemAttributes.DUE_DATE));
		out += "Modified Date " + modifiedDate + "\n\n";
		out+=getAttributeData("Modified By: ", WorkItemAttributes.MODIFIED_BY);
		//out+=getAttributeData("Description: ", WorkItemAttributes.DESCRIPTION);
		out+="\nCustom:\n";
		out+=getAttributeData("Estimated Invest: ", "com.ibm.pew.workitem.attribute.estinvest");
		out+=getAttributeData("Estimated Effort: ", "com.ibm.pew.workitem.attribute.esteffort");
		out+=getAttributeData("Average Cost: ", "com.ibm.pew.workitem.attribute.cost");
		out+=getAttributeData("Total Cost: ", "com.ibm.pew.workitem.attribute.totalcost");

		return out;
		
    	function debug(display){	    		
    		if(doDebug){
        		console.log(scriptname + " " + display);
    		}
    	}
    	
    	function getAttributeData (message,attributeID){
    		debug("Get Attribute Data for " + attributeID);
    		var isSet="";
    		var attributeValue="";
    		var attributeLabel="";
    		var result = message + "\n";
    		
    		try{
    			isSet=workItem.isAttributeSet(attributeID);
    			attributeValue=workItem.getValue(attributeID);
    		} catch (e) {
    			attributeValue = "Exception reading the attribute value";
			}
    		try{
    			attributeLabel=workItem.getLabel(attributeID);
    		} catch (e) {
    			attributeLabel= "Exception reading the attribute label:" + e.toLocaleString();
			}
    		result +="Set: " + isSet + "\nValue= " + attributeValue + "\nLabel= " + attributeLabel;
    		debug(result);
    		return result + "\n\n";
    	}
    }
});
})();

