/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.acme.providers.script.RegExpScriptedValidation");

dojo.require("com.ibm.team.workitem.api.common.Severity");
dojo.require("com.ibm.team.workitem.api.common.Status");

/**
 * requires parameters: <parameters pattern="(\d*M)|(\d*T)|(\d*)" modifier="" message="Invalid format. Use Format: 1M, 4T, or any number..." severity="ERROR"/>
 */
(function() {
var doDebug= true;
var scriptname = "RegExpScriptedValidation";

var Severity= com.ibm.team.workitem.api.common.Severity;
var Status= com.ibm.team.workitem.api.common.Status;

    dojo.declare("com.acme.providers.script.RegExpScriptedValidation", null, {

        validate: function(attribute, workItem, configuration) {
        	debug("Start");
        	
        	// Get the parameters for the regular expression. If the parameters are not configured, throw an exception.
			try {
				var pattern=configuration.getChild("parameters").getStringDefault("pattern", "");
				var modifier=configuration.getChild("parameters").getStringDefault("modifier", "");
			} catch (e) {
				debug("Exception " + e.message);
				throw(e);
			}
        	debug("RegExp: "+pattern+" [" +modifier+"]");
        	
    		var valuetoTest=workItem.getValue(attribute);
        	var verifyPattern=new RegExp(pattern,modifier);
    		var result=verifyPattern.exec(valuetoTest);
    		debug("Test Result: " + result);
    		if(result[0]!=valuetoTest){
    			debug("Validation Fail");
    			//Get the configuration parameters about the severity and error message of this validator
    			var severity= configuration.getChild("parameters").getStringDefault("severity", Severity.ERROR.name);
    			var message= configuration.getChild("parameters").getStringDefault("message", "Regular Expression failed!");
            	debug("Validation: "+severity+" [" +message+"]");   			
    			return new Status(Severity[severity], message);			
    		}
     		debug("Validation Success");
			return Status.OK_STATUS;
			
	    	function debug(display){	    		
	    		if(doDebug){
	        		console.log(scriptname + " " + display);
	    		}
	    	}	
        }
    });
})();