/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2011. All
 * Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.acme.providers.script.ScriptBasedDepartmentValueSet");

(function() {
	var doDebug = true;
	var scriptname = "ScriptBasedDepartmentValueSet";

	dojo.declare("com.acme.providers.script.ScriptBasedDepartmentValueSet",
			null, {

				getFilteredValueSet : function(attributeId, workItem, configuration, filter) {
					debug("- Start");
					var newFilter = ".";
					if (filter != null) {
						newFilter = "^" + filter;
					}

					debug("Filter: " + newFilter);
					var verifyPattern = new RegExp(newFilter, "i");

					var result = [];
					addResult("Development");
					addResult("Sales");
					addResult("Accounting");
					addResult("IT");
					addResult("Production");
					debug("- return results");
					return result;

					/**
					 * Debug output based on the setting of doDebug. Prefixes with script name.
					 * @param display
					 */
					function debug(display) {
						if (doDebug) {
							console.log(scriptname + " " + display);
						}
					}

					/**
					 * Validates a proposed result against a filter and pushes it if it is valid.
					 * @param newResult
					 */
					function addResult(newResult) {
						debug("Test: " + newResult);
						try {
							var verify = verifyPattern.test(newResult);
							debug("Verify: " + verify);
							if (verify) {
								debug("Found!");
								result.push(newResult);
							}
						} catch (e) {
							debug("Exception " + e.message);
							//throw  "Exception: " + e.message;
						}
					}
				}
			});
})();
