/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.acme.providers.script.TotalCostRequiredAttributeCondition");
dojo.require("com.ibm.team.workitem.api.common.WorkItemAttributes");

(function() {
	var doDebug = true;
	var scriptname = "TotalCostRequiredAttributeCondition";
	var WorkItemAttributes = com.ibm.team.workitem.api.common.WorkItemAttributes;
   
   dojo.declare("com.acme.providers.script.TotalCostRequiredAttributeCondition", null, {

        matches: function(workItem, configuration) {
        	debug("Start");
        	
        	// Access to the built in work item attribute ID's
        	var state = workItem.getValue(WorkItemAttributes.STATE);
        	debug("state: " + state); 
        	if(state!="tecReviewWorkflow.state.s3"){
        		return false; // Nothing to do
        	}
        	// Check for the impact
        	var impact = workItem.getLabel("com.ibm.team.workitem.workItemType.risk.impact");
        	debug("impact: " + impact);
        	if(!(impact=="High")){
        		return false;
        	}
         	// Check for the complexity
        	var complexity = workItem.getLabel("com.acme.openup.workitem.attribute.complexity");
        	debug("complexity: " + complexity);
        	if(!(complexity=="Low"||complexity=="Manageable")){
        		return false;
        	}
        	// Total cost attribute is required to have a value.
        	debug("Total Cost Attribute Required");
            return true;
            
	    	function debug(display){	    		
	    		if(doDebug){
	        		console.log(scriptname + " " + display);
	    		}
	    	}	    	
	    }
    });
})();

