/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * TotalCostScriptedCalculatedValue
 *
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.acme.providers.script.WorkflowStateScriptedCalculatedValue");
dojo.require("com.ibm.team.workitem.api.common.WorkItemAttributes");

/**
 * @see https://jazz.net/wiki/bin/view/Main/AttributeCustomization#Using_scripts_for_attribute_cust
 * @see https://jazz.net/wiki/bin/view/Main/AttributeCustomization#API_Example
 */
(function() {
	var doDebug = true;
	var scriptname = "WorkflowStateScriptedCalculatedValue";
	var WorkItemAttributes = com.ibm.team.workitem.api.common.WorkItemAttributes;

	dojo.declare("com.acme.providers.script.WorkflowStateScriptedCalculatedValue", null, {

        getValue: function(attribute, workItem, configuration) {
        	debug("Start"); 
        	
        	var workFlowState = workItem.getValue(WorkItemAttributes.STATE);
        	debug("WorkflowState: " + workFlowState);
        	
        	// Adjust attachment numbers in the code below
        	if(workFlowState=="") return "{{https://clm.example.com:9443/ccm/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/1|New}}";
        	if(workFlowState=="tecReviewWorkflow.state.s1") return "{{https://clm.example.com:9443/ccm/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/2|Proposed}}";
        	if(workFlowState=="tecReviewWorkflow.state.s2") return "{{https://clm.example.com:9443/ccm/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/3|Under Research}}";
        	if(workFlowState=="tecReviewWorkflow.state.s3") return "{{https://clm.example.com:9443/ccm/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/4|Experimental}}";
        	if(workFlowState=="tecReviewWorkflow.state.s4") return "{{https://clm.example.com:9443/ccm/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/5|Approved}}";
        	if(workFlowState=="tecReviewWorkflow.state.s5") return "{{https://clm.example.com:9443/ccm/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/6|Rejected}}";
        	if(workFlowState=="tecReviewWorkflow.state.s6") return "{{https://clm.example.com:9443/ccm/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/7|Adopted}}";
        	return "{{https://clm.example.com:9443/ccm/service/com.ibm.team.workitem.common.internal.rest.IAttachmentRestService/itemName/com.ibm.team.workitem.Attachment/8|Unknown State}}";
 			
	    	function debug(display){	    		
	    		if(doDebug){
	        		console.log(scriptname + " " + display);
	    		}
	    	}	 
	    }
    });
})();